(defun c:roof ( / *error* online inside-p mid bvecs car-sort dd barycent assocfuzz process unique test chklili loop pairs ss pl pli pll plll lwx lw lwxi lwi vecs li lil )

  (vl-load-com)

  (defun *error* ( m )
    (if
      (and
        lwi
        (not (vlax-erased-p lwi))
      )
      (entdel lwi)
    )
    (if m
      (prompt m)
    )
    (princ)
  )

  (defun online ( p1 p2 p3 )
    (equal (distance p1 p3) (+ (distance p1 p2) (distance p2 p3)) 1e-6)
  )

  (defun inside-p ( p )
    (< (distance p (vlax-curve-getclosestpointto lwi p)) (distance p (vlax-curve-getclosestpointto lw p)))
  )

  (defun mid ( p1 p2 )
    (mapcar
      (function (lambda ( a b )
        (/ (+ a b) 2.0)
      ))
      p1
      p2
    )
  )

  (defun bvecs ( pl pli d )
    (if (not pairs)
      (setq pairs
        (mapcar
          (function (lambda ( a b )
            (list a b)
          ))
          pl
          (append (cdr pl) (list (car pl)))
        )
      )
    )
    (if pli
      (setq vecs
        (mapcar
          (function (lambda ( x y )
            (list x (polar x (angle x y) d))
          ))
          pl
          pli
        )
      )
    )
    vecs
  )

  (defun car-sort ( lst cmp / rtn )
    (setq rtn (car lst))
    (foreach itm (cdr lst)
      (if (apply cmp (list itm rtn))
        (setq rtn itm)
      )
    )
    rtn
  )

  (defun dd ( p / dl )
    (foreach tt pairs
      (setq dl
        (cons
          (distance
            (mapcar (function +) (list 0.0 0.0) (trans p 1 (mapcar (function -) (cadr tt) (car tt))))
            (mapcar (function +) (list 0.0 0.0) (trans (car tt) 1 (mapcar (function -) (cadr tt) (car tt))))
          )
          dl
        )
      )
    )
    dl
  )

  (defun barycent ( pl )
    (mapcar (function /)
      (apply (function mapcar)
        (cons (function +)
          pl
        )
      )
      (list (length pl) (length pl) (length pl))
    )
  )

  (defun assocfuzz ( itm lst fuzz )
    (vl-some
      (function (lambda ( x )
        (if (equal itm (car x) fuzz) x)
      ))
      lst
    )
  )

  (defun process ( pl pli d / ips pln ii )
    (if (not vecs)
      (progn
        (setq vecs
          (bvecs pl pli d)
        )
        (setq vecs
          (cons (last vecs)
            (reverse
              (cdr
                (reverse vecs)
              )
            )
          )
        )
      )
    )
    (setq ipss
      (mapcar
        (function (lambda ( a b )
          (list (car a) (cadr a) (inters (car a) (cadr a) (car b) (cadr b) nil) (car b) (cadr b))
        ))
        vecs
        (append (cdr vecs) (list (car vecs)))
      )
    )
    (setq ipss (vl-remove-if (function (lambda ( x ) (null (caddr x)))) ipss))
    (setq ipss
      (vl-remove-if
        (function (lambda ( x / ddd )
          (or
            (not (inside-p (caddr x)))
            (> 2 (- (length (setq ddd (dd (caddr x)))) (length (unique ddd))))
            (vl-some
              (function (lambda ( y )
                (online (car x) (caddr y) (caddr x))
              ))
              (vl-remove x ipss)
            )
          )
        ))
        ipss
      )
    )
    (foreach ip ipss
      (setq
        lil
        (cons
          (list (car ip) (caddr ip))
          lil
        )
        lil
        (cons
          (list (cadddr ip) (caddr ip))
          lil
        )
      )
      (while
        (setq li
          (vl-some
            (function (lambda ( lii )
              (if
                (and
                  (online (car lii) (caddr ip) (cadr lii))
                  (not (equal (car lii) (caddr ip) 1e-6))
                  (not (equal (caddr ip) (cadr lii) 1e-6))
                )
                lii
              )
            ))
            lil
          )
        )
        (setq lil (vl-remove-if (function (lambda ( x ) (equal (cadr x) (cadr li) 1e-6))) lil))
      )
      (setq vecs (vl-remove (assocfuzz (car ip) vecs 1e-2) vecs))
      (setq vecs (vl-remove (assocfuzz (cadddr ip) vecs 1e-2) vecs))
      (setq
        vecs
        (cond
          ( (and (/= 0 (vl-position (caddr ip) (mapcar (function caddr) ipss))) (/= (length pairs) (1+ (vl-position (caddr ip) (mapcar (function caddr) ipss)))))
            (append
              (list
                (list
                  (caddr ip)
                  (polar (caddr ip)
                    (if
                      (setq ii
                        (inters
                          (car (nth (1- (vl-position (caddr ip) (mapcar (function caddr) ipss))) pairs))
                          (cadr (nth (1- (vl-position (caddr ip) (mapcar (function caddr) ipss))) pairs))
                          (car (nth (1+ (vl-position (caddr ip) (mapcar (function caddr) ipss))) pairs))
                          (cadr (nth (1+ (vl-position (caddr ip) (mapcar (function caddr) ipss))) pairs))
                          nil
                        )
                      )
                      (angle ii (caddr ip))
                      (angle
                        (barycent
                          (list
                            (car (nth (1- (vl-position (caddr ip) (mapcar (function caddr) ipss))) pairs))
                            (cadr (nth (1- (vl-position (caddr ip) (mapcar (function caddr) ipss))) pairs))
                            (car (nth (1+ (vl-position (caddr ip) (mapcar (function caddr) ipss))) pairs))
                            (cadr (nth (1+ (vl-position (caddr ip) (mapcar (function caddr) ipss))) pairs))
                          )
                        ) (caddr ip)
                      )
                    )
                    d
                  )
                )
              )
              vecs
            )
          )
          ( (= 0 (vl-position (caddr ip) (mapcar (function caddr) ipss)))
            (append
              (list
                (list
                  (caddr ip)
                  (polar (caddr ip)
                    (if
                      (setq ii
                        (inters
                          (car (last pairs))
                          (cadr (last pairs))
                          (car (nth (1+ (vl-position (caddr ip) (mapcar (function caddr) ipss))) pairs))
                          (cadr (nth (1+ (vl-position (caddr ip) (mapcar (function caddr) ipss))) pairs))
                          nil
                        )
                      )
                      (angle ii (caddr ip))
                      (angle
                        (barycent
                          (list
                            (car (last pairs))
                            (cadr (last pairs))
                            (car (nth (1+ (vl-position (caddr ip) (mapcar (function caddr) ipss))) pairs))
                            (cadr (nth (1+ (vl-position (caddr ip) (mapcar (function caddr) ipss))) pairs))
                          )
                        ) (caddr ip)
                      )
                    )
                    d
                  )
                )
              )
              vecs
            )
          )
          ( (= (length pairs) (1+ (vl-position (caddr ip) (mapcar (function caddr) ipss))))
            (append
              (list
                (list
                  (caddr ip)
                  (polar (caddr ip)
                    (if
                      (setq ii
                        (inters
                          (car (nth (1- (vl-position (caddr ip) (mapcar (function caddr) ipss))) pairs))
                          (cadr (nth (1- (vl-position (caddr ip) (mapcar (function caddr) ipss))) pairs))
                          (car (nth (1+ (vl-position (caddr ip) (mapcar (function caddr) ipss))) (append pairs pairs)))
                          (cadr (nth (1+ (vl-position (caddr ip) (mapcar (function caddr) ipss))) (append pairs pairs)))
                          nil
                        )
                      )
                      (angle ii (caddr ip))
                      (angle
                        (barycent
                          (list
                            (car (nth (1- (vl-position (caddr ip) (mapcar (function caddr) ipss))) pairs))
                            (cadr (nth (1- (vl-position (caddr ip) (mapcar (function caddr) ipss))) pairs))
                            (car (nth (1+ (vl-position (caddr ip) (mapcar (function caddr) ipss))) (append pairs pairs)))
                            (cadr (nth (1+ (vl-position (caddr ip) (mapcar (function caddr) ipss))) (append pairs pairs)))
                          )
                        ) (caddr ip)
                      )
                    )
                    d
                  )
                )
              )
              vecs
            )
          )
        )
      )
      (if (assocfuzz (car ip) vecs 1e-6)
        (setq vecs (vl-remove-if (function (lambda ( x ) (equal (car x) (car ip) 1e-6))) vecs))
      )
      (if (assocfuzz (cadddr ip) vecs 1e-6)
        (setq vecs (vl-remove-if (function (lambda ( x ) (equal (car x) (cadddr ip) 1e-6))) vecs))
      )
    )
    (mapcar (function car) vecs)
  )

  (defun unique ( lst / a ll )
    (while (setq a (car lst))
      (if (vl-some (function (lambda ( x ) (equal x a 1e-6))) (cdr lst))
        (setq ll (cons a ll) lst (vl-remove-if (function (lambda ( x ) (equal x a 1e-6))) (cdr lst)))
        (setq ll (cons a ll) lst (cdr lst))
      )
    )
    (reverse ll)
  )

  (defun test nil
    (and
      (vl-every
        (function (lambda ( x )
          (vl-some
            (function (lambda ( y )
              (equal x y 1e-6)
            ))
            (apply (function append) lil)
          )
        ))
        pl
      )
      (not
        (vl-some
          (function (lambda ( li1 )
            (vl-some
              (function (lambda ( li2 / ip )
                (and
                  (setq ip (inters (car li1) (cadr li1) (car li2) (cadr li2)))
                  (not (equal ip (car li1) 1e-6))
                  (not (equal ip (cadr li1) 1e-6))
                  (not (equal ip (car li2) 1e-6))
                  (not (equal ip (cadr li2) 1e-6))
                )
              ))
              (vl-remove li1 lil)
            )
          ))
          lil
        )
      )
    )
  )

  (defun chklili ( lil / lilpts )
    (setq lilpts (apply (function append) lil))
    (setq lilpts (vl-remove-if-not (function (lambda ( x ) (= (length (vl-remove-if (function (lambda ( y ) (equal x y 1e-6))) lilpts)) (- (length lilpts) 2)))) lilpts))
    lilpts
  )

  (prompt "\nPick closed polygonal LWPOLYLINE...")
  (if
    (setq ss
      (ssget "_+.:E:S" (list (cons 0 "LWPOLYLINE") (cons -4 "&=") (cons 70 1) (cons -4 "<not") (cons -4 "<>") (cons 42 0.0) (cons -4 "not>")))
    )
    (progn
      (setq pl
        (mapcar (function cdr)
          (vl-remove-if
            (function (lambda ( x )
              (/= (car x) 10)
            ))
            (setq lwx
              (entget
                (setq lw
                  (ssname ss 0)
                )
              )
            )
          )
        )
      )
      (setq lwi (vlax-vla-object->ename (car (vlax-invoke (vlax-ename->vla-object lw) 'offset 1e-2))))
      (if (> (vlax-curve-getarea lwi) (vlax-curve-getarea lw))
        (progn
          (entdel lwi)
          (setq lwi (vlax-vla-object->ename (car (vlax-invoke (vlax-ename->vla-object lw) 'offset -1e-2))))
        )
      )
      (setq pli
        (mapcar (function cdr)
          (vl-remove-if
            (function (lambda ( x )
              (/= (car x) 10)
            ))
            (setq lwxi
              (entget lwi)
            )
          )
        )
      )
      (setq loop t)
      (while (and loop (setq pll (process pl pli 1.0)))
        (if
          (or
            ;(test)
            ;(not (chklili lil))
            (<= (cdr (assoc 90 lwx)) (length lil))
            (equal pll plll 1e-6)
          )
          (setq loop nil)
        )
        (setq plll pll pli nil)
      )
      (foreach li lil
        (entmake
          (list
            (cons 0 "LINE")
            (cons 10 (car li))
            (cons 11 (cadr li))
          )
        )
      )
    )
  )
  (*error* nil)
)